(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



modelversion = 5.1; modelcomment = "Two-wire simple pendulum with blades";


modelversion::usage = "modelversion is a number specifying the version of the default model."; 
modelcomment::usage = "modelcomment is a string describing the default model.";


Off[General::spell,General::spell1]


If[$VersionNumber<6., Needs["Graphics`Graphics`"]]


If[$VersionNumber<6., Needs["Graphics`Shapes`"]];


If[$VersionNumber<6., Needs["Graphics`Polyhedra`"]]


If[$VersionNumber < 6, Needs["LinearAlgebra`MatrixManipulation`"]] 


Needs["RotationsXYZ`"]


Needs["StatusWindow`"];


Needs["MatlabExport`"];


Needs["IFOModel`"];


Needs["PendUtil`"];


If[utilitiesversion>=3.0,Null, Print["Incorrect utilities version"];Abort[],Print["Utilities failed to load"];Abort[]];


allvars::usage = "allvars is part of the specification of the model. It should be a list of the position and angle variables for the system. It shouldn't include velocities, or the coordinates of the support structure.";


allvars = {
	x0,y0,z0,yaw0,pitch0,roll0
};


allfloats::usage = "allfloats is part of the specification of the model. It should be a list of position and angle variables for massless junctions between elastic elements.";


allfloats = {
	ql,
	qr
};


allparams::usage = "allparams is part of the specification of the model. It should be a list of the positions and angles describing the state of the support structure, plus any other coordinates that are constant for the purposes of the normal mode calculation but through which one might want to inject a displacement input.";


allparams = {
x00,y00,z00 ,yaw00,pitch00,roll00 
};


velocities::usage = "velocities is a list of symbols (e.g., vx1) for velocities corresponding to the variables in allvars (cf., x1).";


If[!useprecomputed,
	velocities = Table[ToExpression["v"<>ToString[allvars[[i]]]],{i,Length[allvars]}];
    saveprecomputed["velocities.m",velocities],
(*else*)
      getprecomputed["velocities.m"];
];


constraints::usage = "constraints is a list of elastic constants (e.g., kconx1) corresponding to the variables in allvars (cf., x1). They are set to zero in defaultvalues but can be overridden with large values for testing purposes to immobilize particular degrees of freedom.";


constraints = Table[ToExpression["kcon"<>ToString[allvars[[i]]]],{i,Length[allvars]}];


COM = {COMx,COMy,COMz}; usage::COM = "COM is a local coordinate vector for any object, which specifies the centre of mass.";


support={x00,y00,z00,yaw00,pitch00,roll00}; support::usage="support is a list of the parameters specifying the support structure.";


bladeL = Join[b2s[support,{0,dyaw1/2,0}+RotationMatrixXYZBS[0,pitchbl,rollbl].{0,0,ql}],support[[{4,5,6}]]];
bladeL::usage="bladeL is a list of the variables specifying the upper left blade tip.";
bladeR = Join[b2s[support,{0,-dyaw1/2,0}+RotationMatrixXYZBS[0,pitchbr,rollbr].{0,0,qr}],support[[{4,5,6}]]];
bladeR::usage="bladeR is a list of the variables specifying the right blade tip.";


bladeLnom={0,dyaw1/2,0};
bladeLnom::usage = "bladeLnom is the nominal position of the left blade tip relative to the structure.";
bladeRnom={0,-dyaw1/2,0};
bladeRnom::usage = "bladeRnom is the nominal position of the right blade tip relative to the structure.";


bladeLa = {0, 0, 0};
bladeLa::usage="bladeLa is the attachment point of the wire on the upper left blade tip.";
bladeRa = {0, 0, 0};
bladeRa::usage="bladeRa is the attachment point of the wire on the upper right blade tip.";


optic={x0,y0,z0,yaw0,pitch0,roll0};
optic::usage="optic is a list of the variables specifying the optic.";


opticl={0,dyaw2/2,dpitch};
opticl::usage="opticl is the attachment point of the front left fibre at the optic.";
opticr={0,-dyaw2/2,dpitch};
opticr::usage="opticr is the attachment point of the front right fibre at the optic.";


gravlist = {m0 g b2s[optic,COM][[3]]};


wirelist::usage = "wirelist is part of the specification of the model. It is a list of structures defining wires. Each structure containing the following items:\n
{\n
	coordinate list defining first mass,\n
	attachment point for first mass (local coordinates),\n
	attachment vector for first mass,\n
	coordinate list defining second mass,\n
	attachment point for second mass (local coordinates),\n
	attachment vector for second mass,\n
	Young's modulus,\n
	unstretched length,\n
	longitudinal elasticity,\n
	vector defining principal axis 1,\n
	moment of area along principal axis 1,\n
	moment of area along principal axis 2,\n
	linear elasticity type,\n
	angular elasticity type\n
}";
	


wirelist={};


AppendTo[wirelist,{
	bladeL,
	bladeLa, 
	bladelvec,
	optic,
	opticl,
	opticlvec,
	Y0,
	ul0,
	kw0,
	{1,0,0},
	M01,
	M02,
	fibretype,
	fibreatype
}];
AppendTo[wirelist,{
	bladeR,
	bladeRa,
	bladervec,
	optic,
	opticr,
	opticrvec,
	Y0,
	ul0,
	kw0,
	{1,0,0},
	M01,
	M02,
	fibretype,
	fibreatype
}];


springlist = {};


AppendTo[springlist, {
	support,
	bladeLnom,
	{0,pitchbl,rollbl},
	bladeL,
	COM,
	{0,pitchbl,rollbl},
	bladetype,
	{
		{0,0,0,0,0,0},
		{0,0,0,0,0,0},
		{0,0,kbz,0,0,0},
		{0,0,0,0,0,0},
		{0,0,0,0,0,0},
		{0,0,0,0,0,0}
	},
	{0,0,bd*kbz,0,0,0}
}];


AppendTo[springlist, {
	support,
	bladeRnom,
	{0,pitchbr,rollbr},
	bladeR,
	COM,
	{0,pitchbr,rollbr},
	bladetype,
	{
		{0,0,0,0,0,0},
		{0,0,0,0,0,0},
		{0,0,kbz,0,0,0},
		{0,0,0,0,0,0},
		{0,0,0,0,0,0},
		{0,0,0,0,0,0}
	},
	{0,0,bd*kbz,0,0,0}
}];


IM0 = {{I0x, 0, 0}, {0, I0y, 0}, {0, 0, I0z}};			(* optic *)


IM0::usage = "IM0 is the MOI tensor for the optic.";



kinetic::usage = "kinetic is part of the specification of the model. It should be an expression for the kinetic energy in terms of derivatives of the variables (e.g., Dt[x1,t]).";


kinetic = (
	(1/2) m0 Plus@@(Dt[b2s[optic,COM],t]^2) 
	+(1/2) omegaB[yaw0, pitch0, roll0].IM0.omegaB[yaw0, pitch0, roll0]
);


defaultvalues::usage = "defaultvalues is part of the specification of the model. It should be a list of substitutions for all constants. Some of the values can be given symbolically in terms of other constants in the list, but there should be enough given numerically that the whole collection becomes numeric when Recurse[] is applied.";


defaultvalues = {

 g		-> 9.81,

 tx		-> 0.12,			(* thickness of optic *)

 tr		-> 0.14,			(* radius of optic *)

 den0	-> 4000.,			(* density (sapphire) *)

 COMx	-> 0,				(* Suspended mass COM x cohordinate (in local cohordinates) *)
 COMy	-> 0,				(* Suspended mass COM y cohordinate (in local cohordinates) *)
 COMz	-> 0,				(* Suspended mass COM z cohordinate (in local cohordinates) *)

 m0		-> den0*N[Pi]*tr^2*tx,	(* mass of optic *)


 I0x	-> m0*(tr^2/2),			(* moment of inertia (transverse roll) *)

 I0y	-> m0*(tr^2/4+tx^2/12),	(* moment of inertia (longitudinal pitch) *)

 I0z	-> m0*(tr^2/4+tx^2/12),	(* moment of inertia (yaw) *)

 l0	-> 0.6,	    			(* wire length (stretched) *)

 nw0	-> 2,				(* number of wires *)

 r0	-> 180.*10^-6,			(* radius of wire *)

 Y0	-> Ysteel,				(* Youngs Modulus of wire *)

 dpitch		-> 0.001,		(* height of wire break-off above optic local coordinate origin *)

 dyaw1 -> dyaw2,   			(* y-separation of wires at structure *)
 dyaw2 -> 2*tr,    			(* y-separation of wires at optic *)


(* true lengths vertically from attachment point to attactment point etc. *)
(* NOTE this section has been adjusted to remove ambiguity - stretched lengths have been used throughout *)

tl0 -> Sqrt[sl0^2 - (dyaw1/2-dyaw2/2)^2],	(* vertical distance between wire attachment points *)

ltotal  ->  tl0,

dpend -> tl0,								(* ??? vertical distance between upper suspension point and COM ??? *)

ul0->sl0-m0*g/(nw0*kw0*Cos[ArcSin[(dyaw1/2-dyaw2/2)/sl0]]), (* wire unstretched length *)

sl0->l0,									(* wire stretched length *)

si0->(dyaw1/2-dyaw2/2)/sl0,					(* sine of wire angle *)
c0->Sqrt[sl0^2-(dyaw1/2-dyaw2/2)^2]/sl0,	(* cosine of wire angle *)

A0->N[Pi]*r0^2, (* effective average cross-sectional area of fibres *)

kw0->Y0*A0/sl0, (* net longitudinal elasticity of fibres *)

M01-> (1/4) N[Pi] r0^4, (* moment of area of fibre in direction "1" *)
M02-> (1/4) N[Pi] r0^4, (* moment of area of fibre in direction "2" *)

vertblades->True, (* switch specifiying whether the blades act vertically or at right angles to wires *)

pitchbl->0,  (* pitch mounting angle of left blade spring *)
pitchbr->0,  (* pitch mounting angle of right blade spring *)
rollbl->If[vertblades,0,-ArcSin[si0]],  (* roll mounting angle of left blade spring *)
rollbr->If[vertblades,0,ArcSin[si0]],  (* roll mounting angle of right blade spring *)
kbz -> 300, (* scale roughly from quad: 2400*10/80 *)
bd->If[vertblades,1,1/c0]*(m0/2)*g/kbz,
btx->0.03,		(* display size of blade tip *)
bty->0.03,		(* display size of blade tip *)
btz->0.03,		(* display size of blade tip *)

(* damping stuff *)
temperature      -> ifo[Suspension,Temp],
boltzmann      -> ifo[Constants,kB],

alphasilica-> ifo[Suspension,Silica,Alpha],(* coeff. thermal expansion *)
betasilica-> ifo[Suspension,Silica,dlnEdT], (* temp. dependence Youngs modulus *)
rhosilica-> ifo[Suspension,Silica,Rho], (* mass density *)
Csilica-> ifo[Suspension,Silica,C], 
Ksilica-> ifo[Suspension,Silica,K],   (* W/(m kg)       *)
Ysilica    -> ifo[Suspension,Silica,Ey], 
phisilica->2. 10^-8,						(* intrinsic/bulk damping *)
phissilica->ifo[Suspension,Silica,Phi], (* surface damping, units of m *)

rhosteel  -> ifo[Suspension,C70Steel,Rho],
Csteel    -> ifo[Suspension,C70Steel,C],
Ksteel    -> ifo[Suspension,C70Steel,K],
Ysteel    -> ifo[Suspension,C70Steel,Ey], 
alphasteel  -> ifo[Suspension,C70Steel,Alpha], 
betasteel   -> ifo[Suspension,C70Steel,dlnEdT], 
phisteel -> ifo[Suspension,C70Steel,Phi], 

rhomarag   -> ifo[Suspension,MaragingSteel,Rho], 
Cmarag     -> ifo[Suspension,MaragingSteel,C], 
Kmarag     -> ifo[Suspension,MaragingSteel,K], 
Ymarag     -> ifo[Suspension,MaragingSteel,Ey],
alphamarag   -> ifo[Suspension,MaragingSteel,Alpha], 
betamarag    -> ifo[Suspension,MaragingSteel,dlnEdT], 
phimarag -> ifo[Suspension,MaragingSteel,Phi],
tmU    -> ifo[Suspension,Stage,4,Blade], (* ?????? *)
tmI    -> ifo[Suspension,Stage,3,Blade],  (* ?????? *)
tmL    -> ifo[Suspension,Stage,2,Blade],  (* ?????? *)

deltablade->Ymarag*alphamarag^2*temperature/(rhomarag*Cmarag), (* cf Bench delta_v1 *)
taublade->rhomarag*Cmarag*tmU^2/(Kmarag*N[Pi]^2),
damping[imag,bladetype] -> ((phimarag + deltablade*(2*N[Pi]*#1*taublade)/(1+(2*N[Pi]*#1*taublade)^2))&),

magicnumber->7.32 10^-2,
deltafibre->Ysilica*temperature*(alphasilica-betasilica*g*(m0)/(nw0*N[Pi]*r0^2*Ysilica))^2/(rhosilica*Csilica), 
tausilica->magicnumber*rhosilica*Csilica*4*(N[Pi]*r0^2)/N[Pi], (* cf Bench tau_si *)
damping[imag,fibretype] -> ((phisilica + phissilica/r0/2)&),
damping[imag,fibreatype] -> ((phisilica + phissilica/r0 + deltafibre*(2*N[Pi]*#1*tausilica)/(1+(2*N[Pi]*#1*tausilica)^2))&),
x00->0,
y00->0,
z00->0,
yaw00->0,
pitch00->0,
roll00->0,
Sequence@@(Replace[constraints,x_:>(x->0),1]) (* generates and splices in substitutions of form kconx1->0 *)
};


g::usage = "g is local gravity.";

tx::usage = "ux is thickness of optic.";	
tr::usage = "uy is radius of optic.";	
den0::usage = "den0 is density of optic.";
m0::usage = "m0 is mass of optic.";
I0x::usage = "I0x is x-axis MOI of optic.";
I0y::usage = "I0y is y-axis MOI of optic.";
I0z::usage = "I0z is z-axis MOI of optic.";

l0::usage = "l0 is part of the specification of the model and represents the stretched wire (fibre) length from structure to optic.";

ul0::usage = "ul0 is unstretched wire (fibre) length from structure to optic.";

sl3::usage = "sl0 is stretched wire (fibre) length from structure to optic.";

si0::usage = "si0 is sine of angle of fibres.";

c0::usage = "c0 is cosine of angle of fibres.";

nw0::usage = "nw0 is number of wires (fibres) from structure to optic.";

r0::usage = "r0 is radius of wires (fibres) from structure to optic.";

Y0::usage = "Y0 is Young's modulus of wires (fibres) from structure to optic.";

dpitch::usage = "dpitch is the height of the wire attachment points above the center (not COM) of the optic.";
dyaw1::usage = "dyaw1 is the y-direction separation of the wire attachment points at the structure.";
dyaw2::usage = "dyaw2 is the y-direction separation of the wire attachment points at the optic.";
dx::usage = "dx is the x-direction separation of the wires.";

tl0::usage = "tl0 is the vertical distance from structure attachment point to the COM of the optic.";

ltotal::usage = "ltotal is the vertical distance from the structure attachement point to the COM of the optic.";

A0::usage = "A0 is effective average cross-sectional area of wires (fibres) from structure to optic for the purposes of calculating the longitudinal elasticity.";

kw0::usage = "kw0 is net longitudinal elasticity of wires (fibres) from structure to optic.";

M01::usage = "M31 is the moment of area of wires (fibres) from structure to optic in direction \"1\"";
M02::usage = "M32 is the moment of area of wires (fibres) from structure to optic in direction \"2\"";

(* damping stuff *)

damping::usage = "damping[imag,dampingtype] is a Mathematica pure function giving the frequency dependence of the imaginary (i.e., lossy) part of any potential terms tagged with symbol dampingtype. It defaults to 0& but can be given a value via a substitution in defaultvalues. damping[real,dampingtype] is the corresponding real (i.e., elastic) multiplier. It defaults to 1&.";

temperature::usage = "temperature is, well, guess.";

alphasilica::usage = "alphasilica is the coefficient of thermal expansion for silica.";
betasilica::usage = "betasilica is the temperature dependence of Young's modulus for silica.";
rhosilica::usage = "rhosilica is the density for silica.";
Csilica::usage = "Csilica is the heat capacity for silica.";
Ksilica::usage = "Ksilica is the bulk modulus for silica.";
Ysilica::usage = "Ysilica is the Young's modulus for silica.";
phisilica::usage = "phisilica is the bulk loss angle for silica.";
phissilica::usage = "phissilica is the surface loss angle (units of m) for silica.";

alphasteel::usage = "alphasteel is the coefficient of thermal expansion for C70 steel.";
betasteel::usage = "betasteel is the temperature dependence of Young's modulus for C70 steel.";
rhosteel::usage = "rhosteel is the density for C70 steel.";
Csteel::usage = "Csteel is the heat capacity for C70 steel.";
Ksteel::usage = "Ksteel is the bulk modulus for C70 steel.";
Ysteel::usage = "Ysteel is the Young's modulus for C70 steel.";
phisteel::usage = "phisteel is the bulk loss angle for C70 steel.";

alphamarag::usage = "alphamarag is the coefficient of thermal expansion for maraging steel.";
betamarag::usage = "betamarag is the temperature dependence of Young's modulus for maraging steel.";
rhomarag::usage = "rhomarag is the density for maraging steel.";
Cmarag::usage = "Cmarag is the heat capacity for maraging steel.";
Kmarag::usage = "Kmarag is the bulk modulus for maraging steel.";
Ymarag::usage = "Ymarag is the Young's modulus for maraging steel.";
phimarag::usage = "phimarag is the bulk loss angle for maraging steel.";

magicnumber::usage = "magicnumber is a geometrical factor for thermoelastic damping.";
deltafibre::usage = "deltafibre is the thermoelastic damping parameter delta for the wires from mass I to the optic.";
tausilica::usage = "tausilica is the thermoelastic damping parameter tau for the wires from mass I to the optic.";


initparam::usage = "initparam is part of the specification of the model. It should give a list of substitutions for the nominal values of all the parameters in allparams. The values can be given symbolically in terms of constants defined in the list defaultvalues.";


initparam = {
	x00->0,
	y00->0,
	z00->0,
	yaw00->0,
	pitch00->0,
	roll00->0
};


startpos::usage = "startpos is part of the specification of the model. It should be a list of approximate values of all variables to be used as a starting point for minimizing the potential. The values can be given symbolically in terms of constants defined in the list defaultvalues.";


startpos = {
	ql->0,
	qr->0,
	x0->0,
	y0->0,
	z0->z00-tl0-dpitch,
	yaw0->0,
	pitch0->0,
	roll0->0
};


doplots = True;


doplots::usage = "doplots is a switch that enables plotting when set to True";


e2b::usage = "e2b is a matrix that converts the angular displacement elements of an eigenvector from differential yaw/pitch/roll format to body coordinates.";


e2b := DiagonalBlockMatrix[{
	IdentityMatrix[3],
	omegaIB[yaw0,pitch0,roll0]
}]/.optval; 


e2s::usage = "e2s is a matrix that converts the angular displacement elements of an eigenvector from differential yaw/pitch/roll format to body coordinates.";


e2s := DiagonalBlockMatrix[{
	IdentityMatrix[3],
	omegaIS[yaw0,pitch0,roll0]
}]/.optval; 


e2i::usage = "e2i is a matrix that converts the angular displacement elements of an eigenvector from differential yaw/pitch/roll format to \"independent\" yaw/pitch/roll format, i.e., in terms of new yaw, pitch and roll variables defined so that the equilibrium position is yawnew=pitchnew=rollnew=0.";


e2ni := DiagonalBlockMatrix[{
	IdentityMatrix[3],
	omegaSNI.omegaIS[yaw0,pitch0,roll0]
}]/.optval; 


supportxinput = makeinputvector[x00];


supportxinput::usage = "supportxinput is a vector representing excitation of the support in x.";


supportyinput = makeinputvector[y00];


supportyinput::usage = "supportyinput is a vector representing excitation of the support in y.";


supportzinput = makeinputvector[z00];


supportzinput::usage = "supportzinput is a vector representing excitation of the support in z.";


supportyawinput = makeinputvector[yaw00];


supportyawinput::usage = "supportyawinput is a vector representing excitation of the support in yaw.";


supportpitchinput = makeinputvector[pitch00];


supportpitchinput::usage = "supportpitchinput is a vector representing excitation of the support in pitch.";


supportrollinput = makeinputvector[roll00];


supportrollinput::usage = "supportrollinput is a vector representing excitation of the support in roll.";


opticxoutput = makeoutputvector[x0];


opticyoutput = makeoutputvector[y0];


opticzoutput = makeoutputvector[z0];


opticyawoutput = makeoutputvector[yaw0];


opticpitchoutput = makeoutputvector[pitch0];


opticrolloutput = makeoutputvector[roll0];


opticindyawoutput := makeoutputvector[yaw0].e2i;


opticindpitchoutput := makeoutputvector[pitch0].e2i;


opticindrolloutput := makeoutputvector[roll0].e2i;


maxx:=Max[tx];
maxy:=Max[dyaw2/2];


ztop:=z00/.constval;
zbottom:=z00-tl0-dpitch-tr/.constval;


If[True,
	supportpoints[sub_] := {
		Graphics3D[Point[support/.constval/.sub]]
	};
	referencemarkers := {
		Graphics3D[Point[{+maxx/2,+maxy/2, ztop}/.constval]],
		Graphics3D[Point[{+maxx/2,-maxy/2, ztop}/.constval]],
		Graphics3D[Point[{-maxx/2,+maxy/2, ztop}/.constval]],
		Graphics3D[Point[{-maxx/2,-maxy/2, ztop}/.constval]],
		Graphics3D[Point[{+maxx/2,+maxy/2, zbottom}/.constval]],
		Graphics3D[Point[{+maxx/2,-maxy/2, zbottom}/.constval]],
		Graphics3D[Point[{-maxx/2,+maxy/2, zbottom}/.constval]],
		Graphics3D[Point[{-maxx/2,-maxy/2, zbottom}/.constval]]
	};
];


If[True,
	wires[sub_] := {
		Graphics3D[
			Line[
				{
					b2s[wirelist[[1,w$obj1]],wirelist[[1,w$pos1]]],
					b2s[wirelist[[1,w$obj2]],wirelist[[1,w$pos2]]]
				}/.constval/.sub
			]
		],
		Graphics3D[
			Line[
				{
					b2s[wirelist[[2,w$obj1]],wirelist[[2,w$pos1]]],
					b2s[wirelist[[2,w$obj2]],wirelist[[2,w$pos2]]]
				}/.constval/.sub
			]
		]
	}
];



If[$VersionNumber<6.,
	bladeLoutline[sub_] := TranslateShape[
		RotateShapeXYZ[
			Graphics3D[
				MyCuboid[
					{-btx/2,-bty/2,-btz/2},{btx/2,bty/2,btz/2}
				]
			],
			0, 0, 0
		],
		bladeL[[{1,2,3}]]
	]/.constval/.sub,
(* else v6+ *)
	bladeLoutline[sub_] := Graphics3D[
		Translate[
			Rotate[
				Rotate[
					Rotate[		
						Cuboid[
							{-btx/2,-bty/2,-btz/2},{btx/2,bty/2,btz/2}
						],
						0, {1,0,0}, {0,0,0}
					],
					0, {0,1,0}, {0,0,0}
				],
				0, {0,0,1}, {0,0,0}
			],
			bladeL[[{1,2,3}]]
		]
	]/.constval/.sub
];


If[$VersionNumber<6.,
	bladeRoutline[sub_] := TranslateShape[
		RotateShapeXYZ[
			Graphics3D[
				MyCuboid[
					{-btx/2,-bty/2,-btz/2},{btx/2,bty/2,btz/2}
				]
			],
			0, 0, 0
		],
		bladeR[[{1,2,3}]]
	]/.constval/.sub,
(* else v6+ *)
	bladeRoutline[sub_] := Graphics3D[
		Translate[
			Rotate[
				Rotate[
					Rotate[
						Cuboid[
							{-btx/2,-bty/2,-btz/2},{btx/2,bty/2,btz/2}
						],
						0, {1,0,0}, {0,0,0}
					],
					0, {0,1,0}, {0,0,0}
				],
				0, {0,0,1}, {0,0,0}
			],
			bladeR[[{1,2,3}]]
		]
	]/.constval/.sub
];


If[$VersionNumber<6.,
	opticoutline[sub_] := TranslateShape[
		RotateShapeXYZ[
			RotateShapeXYZ[
				Graphics3D[
					MyOpenCylinder5[
						tr,{-tx/2,tx/2},20
					]
				],
				0, Pi/2, 0
			],
			yaw0, pitch0, roll0
		],
		{x0, y0, z0}
	]/.constval/.sub,
(* else v6+ *)
	opticoutline[sub_] := Graphics3D[
		Translate[
			Rotate[
				Rotate[
					Rotate[
						Rotate[
							MyOpenCylinder[
								tr,{-tx/2,tx/2},20
							],
							Pi/2, {0,1,0}, {0,0,0}
						],
						roll0, {1,0,0}, {0,0,0}
					],
					pitch0, {0,1,0}, {0,0,0}
				],
				yaw0, {0,0,1}, {0,0,0}
			],
			optic[[{1,2,3}]]
		]
	]/.constval/.sub
];


eigenplot::usage = "eigenplot[e, f, {x, y, z},fm] makes a plot of the eigenvector e, scaled by a factor f, with viewpoint {x,y,z}.";


eigenplot[e_, ff_, {x_, y_, z_}, fm_] := If[
	doplots,
	Block[
		{s=tosub[ff e,fm]},
		Show[
			referencemarkers,
			wires[s],
			(*opticpoints[s],*)
			(*supportpoints[s],*)
			bladeLoutline[s],
			bladeRoutline[s],
			opticoutline[s],
			ViewPoint->{x, y, z},
			PlotRange->{{-1.5 maxx,1.5 maxx},{-1.5 maxy,1.5 maxy},{zbottom-0.1,ztop}}/.constval
		]
	],
	Print["Plots switched off (doplots = False)"]
]


pad::usage = "pad[ev] takes an eigenvector and inserts dummy values where angle variables had been suppressed, so as to make even groups of six.";


pad[e_]:=Partition[e,6] 


pretty::usage = "pretty[ev] prints an eigenvector in a pretty table format with headings.";


pretty[e_] := TableForm[Transpose[Join[{{"","optic"}},Transpose[Join[{{"x","y","z","yaw","pitch","roll"}},pad[e]]]]]] 


pretty[h_,e_] :=Chop[Join[{{"f","x","y","z","yaw","pitch","roll"}}, Transpose[Join[{h},Transpose[pad[e]]]]]]


longpitchQ[e_] := Block[
	{s=ToString[important[e][[1]]]},
	StringPosition[s,"pitch"]=={{1,5}}
	||StringPosition[s,"x"]=={{1,1}}
]

transrollQ[e_] := Block[
	{s=ToString[important[e][[1]]]},
	(
		StringPosition[s,"y"]=={{1,1}}
		&&StringPosition[s,"yaw"]=={}
	)
	||StringPosition[s,"roll"]=={{1,4}}
]

yawQ[e_] := Block[
	{s=ToString[important[e][[1]]]},
	StringPosition[s,"yaw"]=={{1,3}}
]

vertQ[e_] := Block[
	{s=ToString[important[e][[1]]]},
	StringPosition[s,"z"]=={{1,1}}
]
